/**
 * łivB
 */
class BigHeadSudoku : public Sudoku {
public:
	BigHeadSudoku( int rows, int cols, BoxVal maxval);
	~BigHeadSudoku(){}
	YesNo set_local_maxval( BoxVal maxval); // őlw肷B
	void solve_user();
	void squeeze_boxval( int row, int col, Koho koho);
	void decided( int row, int col, BoxVal boxval);
	void print() const;

private:
	YesNo check_complete();
	YesNo check_box_less_than( int row1, int col1, int row2, int col2) const;	// [row1][col1] < [row2][col2] ?
	void squeeze_koho( int row, int col);
	BoxVal get_min_koho( int row, int col) const;
	BoxVal get_max_koho( int row, int col) const;

private:
	int           m_local_maxval;	// Ɏw肳Ăől
};

BigHeadSudoku::BigHeadSudoku( int rows, int cols, BoxVal maxval) : Sudoku( rows, cols, maxval)
{
	m_local_maxval= maxval;				// Ŏw肳͂C芸őlݒ肵ĂB
	activate_row_blocks();
	activate_col_blocks();
	calc_box_blocks();
}

/**
 * őlw肷B
 */
YesNo BigHeadSudoku::set_local_maxval( BoxVal maxval)
{
	if( maxval >= 1 && maxval <= m_maxval) {
		m_local_maxval= maxval;
		return    YES;
	}
	return    NO;
}

/**
 * lm肵B
 * Box蒼Box́CBox傫B
 * Box́CBox菬B
 */
void BigHeadSudoku::decided( int row, int col, BoxVal boxval_decided)
{
	if( row >= 1) {								// Box
		for( BoxVal boxval=boxval_decided-1; boxval>= 1; boxval--) {
			remove_koho( row-1, col, boxval);	// ɂBox̌l͂Box̌l傫̂ŁĈ폜B
		}
	}
	if( row < m_rows-1) {					// Box
		for( BoxVal boxval=boxval_decided+1; boxval<= m_maxval; boxval++) {
			remove_koho( row+11, col, boxval); // ɂBox͂̌l菬Ȃ̂ŁC傫̂폜B
		}
	}
}

/**
 * Box̒l͏ɉBox̒l傫B
 * ABox󔒂̏ꍇ́C̎dlɂi荞݂͍sȂB
 */
void BigHeadSudoku::solve_user()
{
	for( int row=0; row< m_rows-1; row++) {
		for( int col=0; col< m_cols; col++) {
			squeeze_koho( row, col);
		}
	}
}

/**
 * dlɏ]Čli荞ށB
 * Box͏ɉɂBox傫ȒlɂȂ̂ł𗘗pči荞ށB
 * A m_local_maxval 傫ȐlɎcĂƂ́C̐i荞ނƂoȂB
 * m_local_maxval 傫ȐlɎcĂƂ́C̐Ɋm肷ƁC
 * ͋󔒂Ɍ̂ŁC̐ɉeȂƂɂȂB
 */
void BigHeadSudoku::squeeze_koho( int row, int col)
{
	// [row][col]̌l͏[row+1][col]傫B
	BoxVal        boxval_min = get_min_koho( row, col);
	Box&          box2 = m_box[row+1][col];
	BoxVal        boxval;
	for( boxval=boxval_min+1; boxval<= m_local_maxval; boxval++) {
		if( box2.m_koho & kohobit[boxval]) {
			Sudoku::remove_koho( row+1, col, boxval);
		}
	}
	BoxVal        boxval_max = get_max_koho( row+1, col);
	Box&          box1 = m_box[row][col];
	for( boxval=boxval_max; boxval>= 1; boxval--) {
		if( box1.m_koho & kohobit[boxval]) {
			Sudoku::remove_koho( row, col, boxval);
		}
	}
}

/**
 * [row][col]̌l̍ŏl߂B
 * lm肵ĂƂ͊mlԂB
 * 傫ȐcĂƂ́Cm_maxvalԂB
 */
BoxVal BigHeadSudoku::get_min_koho( int row, int col) const
{
	const Box&    box = m_box[row][col];
	if( box.m_boxval != BoxValNone) return    box.m_boxval;	// lm肵Ă̂ŊmlԂ
	BoxVal        boxval;
	for( boxval=m_local_maxval+1; boxval<= m_maxval; boxval++) { // 傫ȐcĂ邩?
		if( box.m_koho & kohobit[boxval]) return    m_maxval; // cĂƂ͏̐ɉeĂ͂ȂȂ̂m_maxvalԂB邱Ƃŏ̐̍i荞݂͍sȂB
	}
	for( boxval=1; boxval<= m_local_maxval; boxval++) { // lTĂ
		if( box.m_koho & kohobit[boxval]) return    boxval;
	}
	return    m_maxval;
}

/**
 * [row][col]̌l̍ől߂B
 * lm肵ĂƂ͊mlԂB
 * 傫ȐcĂƂ0ԂB
 */
BoxVal BigHeadSudoku::get_max_koho( int row, int col) const
{
	const Box&    box = m_box[row][col];
	if( box.m_boxval != BoxValNone) return    box.m_boxval;	// lm肵Ă̂ŊmlԂ
	BoxVal        boxval;
	for( boxval=m_local_maxval+1; boxval<= m_maxval; boxval++) { // 傫ȐcĂ邩?
		if( box.m_koho & kohobit[boxval]) return    0; // cĂƂ͉̐ɉeĂ͂ȂȂ̂0ԂB邱Ƃŉ̐̍i荞݂͍sȂB
	}
	for( boxval=m_local_maxval; boxval>= 1; boxval--) { // ォlTĂ
		if( box.m_koho & kohobit[boxval]) return    boxval;
	}
	return    0;
}

/**
 */
void BigHeadSudoku::squeeze_boxval( int row, int col, Koho koho)
{
	int           cnt_koho = 0;
	int           row1, col1;
	BoxVal        boxval1;
	for( BoxVal boxval=1; boxval<= m_local_maxval; boxval++) {
		if( m_box[row][col].m_koho & kohobit[boxval]) {
			cnt_koho++;
			row1      = row;
			col1      = col;
			boxval1   = boxval;
			if( cnt_koho >= 2) return; // l2ȏ゠̂ŌłȂB
		}
	}
	if( cnt_koho == 1) {					// w̒lȉ̌l1̂ŁClłB
		set_boxval( row1, col1, boxval1);
	}
}

/**
 */
YesNo BigHeadSudoku::check_complete()
{
	YesNo         yn_complete = YES;
	m_yn_data_error   = NO;
	Koho          koho_local = get_all_koho( m_local_maxval);
	Koho          koho_big = get_all_koho() & ~koho_local;
	for( int row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			Box&      box = m_box[row][col];
			if( box.m_boxval != BoxValNone) {	// lm肵Ă̂ŖȂ
				// Ô߂Box̏㉺̒l`FbNB
				if( row >= 1) {
					if( check_box_less_than( row-1, col, row, col)) { // ̕?
						yn_complete = NO;
						m_yn_data_error   = YES; // ͎dlɔ
					}
				}
				if( row < m_rows-1) {
					if( check_box_less_than( row, col, row+1, col)) { // ̕
						yn_complete = NO;
						m_yn_data_error   = YES; // ͎dlɔ
					}
				}
			}
			else {										// lm肵ĂȂB
				Koho    koho = box.m_koho;
				if( (koho&koho_local) == 0) {	// ȌlcĂȂB
					if( (koho&koho_big) != 0) {	// 傫ȌlcĂB
						// Box͑傫Ȓlݒ肳͂B
						// m肵ĂƌȂĖȂB
					}
					else {
						yn_complete = NO;
						m_yn_data_error = YES; // l̂ɒlm肵ĂȂC肾B
					}
				}
				else {									// ȌlcĂB
					yn_complete   = NO;
				}
			}
		}
	}
	return    yn_complete;
}

/**
 * [row1][col1] < [row2][col2] ?
 */
YesNo BigHeadSudoku::check_box_less_than( int row1, int col1, int row2, int col2) const
{
	if( row1 < 0 || row1 >= m_rows) return    NO;	// rłȂƂNOԂB
	if( row2 < 0 || row2 >= m_rows) return    NO;
	BoxVal        boxval1 = m_box[row1][col1].m_boxval;
	BoxVal        boxval2 = m_box[row2][col2].m_boxval;
	if( boxval1 >= m_local_maxval) boxval1 = BoxValNone; // r̂͏Ȓl
	if( boxval2 >= m_local_maxval) boxval2 = BoxValNone;
	if( boxval1 != BoxValNone && boxval2 != BoxValNone && boxval1 <= boxval2) return    YES; // 
	return    NO;
}

/**
 */
void BigHeadSudoku::print() const
{
	char          m_rowline[1024];
	{
		int i = 0;
		for( int col=0; col< m_cols; col++) {
			if( col == 0) m_rowline[i++] = '+';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
		}
		m_rowline[i++]= '+';
		m_rowline[i]= NIL;
	}

	cstring ss = "EPQRSTUVWX10111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364";
	int           row, col;
	int           n=0;
	for( row=0; row< m_rows; row++) {
		if( row == 0) ps( "%s\n", m_rowline);
		for( col=0; col< m_cols; col++) {
			if( col == 0) ps( "|");
			ps( "%-.2s", ss+get_boxval(row,col)*2);
			if( get_boxval(row,col) != BoxValNone) n++;
		}
		ps( "|\n");
	}
	ps( "%s\n", m_rowline);
	ps( "萔 : %d \n", n);
}

