const byte COLWALL  = 0x01;
const byte ROWWALL  = 0x02;
class GeomSudoku : public Sudoku {
public:
	GeomSudoku( int rows, int cols, int maxval);
	~GeomSudoku(){}
	virtual Sudoku* create_clone( const Sudoku* sudoku); // @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
	void print() const;
	YesNo set_row_wall( int row, int pos[], int n);
	YesNo set_col_wall( int col, int pos[], int n);
	YesNo init_end();							// ό`ubN̎w

protected:
	GeomSudoku(){}							// create_clone()Ŏgp

private:
	int find_block( int row, int col, byte block_id/*1IW*/, int cntbox, int cntmax, BoxPos pos[MAXVAL]); // ߂lBlockBOX
	
private:
	byte          m_wall[ROWS+1][COLS+1];	// COLWALL:ǁCROWWALL:c, COLWALL|ROWWALL:
	byte          m_id[ROWS][COLS];	// BlockIdł͖̂Œ
};

GeomSudoku::GeomSudoku( int rows, int cols, int maxval) : Sudoku( rows, cols, maxval)
{
	memset( m_wall, 0, sizeof(m_wall[0][0])*(ROWS+1)*(COLS+1));
	memset( m_id, 0, sizeof(m_id[0][0])*(ROWS)*(COLS));
	activate_row_blocks();
	activate_col_blocks();
	//calc_box_blocks();
}

/**
 * @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
 */
Sudoku* GeomSudoku::create_clone( const Sudoku* src0)
{
	if( src0 == NULL) {
		GeomSudoku* sudoku = new GeomSudoku();
		return    sudoku->create_clone( this);
	}
	const GeomSudoku* src = (const GeomSudoku*)src0;
	memcpy( m_wall, src->m_wall, sizeof(m_wall));
	memcpy( m_id, src->m_id, sizeof(m_id));
	return    Sudoku::create_clone( src0);
}

YesNo GeomSudoku::set_row_wall( int col, int pos[], int n)
{
	int           row = -1;
	for( int i=0; i< n; i++) {
		row         += pos[i];
		if( row != m_rows && !exist_box( row, col)) {
			pe( "[%d][%d] not exist\n", row, col);
			return    NO;
		}
		m_wall[row][col]    |= ROWWALL;
	}
	if( row != m_rows-1) {
		pe( "s:%d,ҍs:%d at %d\n", row+1, m_rows, col);
		return    NO;
	}
	return    YES;
}

YesNo GeomSudoku::set_col_wall( int row, int pos[], int n)
{
	int           col = -1;
	for( int i=0; i< n; i++) {
		col         += pos[i];
		if( col != m_cols && !exist_box( row, col)) {
			pe( "[%d][%d] not exist\n", row, col);
			return    NO;
		}
		m_wall[row][col]    |= COLWALL;
	}
	if( col != m_cols-1) {
		pe( ":%d,җ:%d at %ds\n", col+1, m_cols, row);
		return    NO;
	}
	return    YES;
}

YesNo GeomSudoku::init_end()
{
	int           cntbox;
	int           block_id = 0;
	// ̕ǂ͊ set_row_wall(), set_col_wall() ō쐬Ă̂Ŏɕǂ
	int           row, col;
	for( row=0; row< m_rows; row++) {
		m_wall[row][m_cols-1] |= COLWALL;
	}
	for( col=0; col< m_cols; col++) {
		m_wall[m_rows-1][col] |= ROWWALL;
	}
	for( row=0; row< m_rows; row++) {
		for( col=0; col< m_cols; col++) {
			ps( " ");
			if( m_wall[row][col]& COLWALL) ps( "|");
			else ps( " ");
		}
		ps( "\n");
		for( col=0; col< m_cols; col++) {
			if( m_wall[row][col]& ROWWALL) ps( "-");
			else ps (" ");
			ps( " ");
		}
		ps( "\n");
	}
	// ǂ̓BlockĂB
	BoxPos        pos[MAXVAL];
	for( row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			ps( "[%d][%d]%d ", row, col, m_wall[row][col]);
			if( m_id[row][col] == 0) { // ܂BlockɊ蓖ĂĂȂBOXSĂ𒲂ׂ
				cntbox  = find_block( row, col, ++block_id, 0, m_maxval, pos);
				ps( "cntbox:%d\n", cntbox);
				if( cntbox != m_maxval) return    NO;
				activate_extra_blocks( pos);
			}
		}
		ps( "\n");
	}
	calc_box_blocks();
	ps( "call sudoku::init_end\n");
	return    Sudoku::init_end();
}

/**
 * [row][col]ID̊蓖ĂĂȂBoxǂɓ܂ōċAIɒTB
 */
int GeomSudoku::find_block( int row, int col, byte block_id, int cntbox, int cntmax, BoxPos pos[MAXVAL])
{
	if( m_id[row][col]) return    cntbox;
	ps( "find_block(%d,%d,%d,%d,%d)wall:%d\n", row, col, block_id, cntbox, cntmax,m_wall[row][col]);
	if( cntbox >= cntmax) return    0; // pos[MAXVAL]Ő錾Ă̂0ԂăG[oł悤ɂ
	m_id[row][col]= block_id;
	pos[cntbox]   = rowcol2pos( row, col);
	cntbox++;
	if( !(m_wall[row][col] & COLWALL)) {
		cntbox      = find_block( row, col+1, block_id, cntbox, cntmax, pos);
	}
	if( !(m_wall[row][col] & ROWWALL)) {
		cntbox      = find_block( row+1, col, block_id, cntbox, cntmax, pos);
	}
	if( col > 0 && !(m_wall[row][col-1] & COLWALL)) {
		cntbox      = find_block( row, col-1, block_id, cntbox, cntmax, pos);
	}
	if( row > 0 && !(m_wall[row-1][col] & ROWWALL)) {
		cntbox      = find_block( row-1, col, block_id, cntbox, cntmax, pos);
	}
	return    cntbox;
}

/**
 */
void GeomSudoku::print() const
{
	char          m_rowline[1024];
	{
		int i = 0;
		for( int col=0; col< m_cols; col++) {
			if( col == 0) m_rowline[i++] = '+';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
		}
		m_rowline[i++]= '+';
		m_rowline[i]= NIL;
	}

	cstring ss = "EPQRSTUVWX1011121314151617181920212223242526272829303132333435363738394041424344454647484950";
	int           row, col;
	int           n=0;
	for( row=0; row< m_rows; row++) {
		if( row == 0) ps( "%s\n", m_rowline);
		for( col=0; col< m_cols; col++) {
			if( col == 0) ps( "");
			ps( "%-.2s", ss+get_boxval(row,col)*2);
			if( m_wall[row][col] & COLWALL) ps( "");
			else                            ps( "");
			if( get_boxval(row,col) != BoxValNone) n++;
		}
		ps( "\n");
		// sԂ̕ǂo͂B
		for( col=0; col< m_cols; col++) {
			if( col == 0) {
				if( m_wall[row][col] & ROWWALL) ps( "");
				else ps( "");
			}
			if( m_wall[row][col] & ROWWALL) ps( "");
			else                            ps( "");
			ps( "");
		}
		ps( "\n");
	}
	ps( "%s\n", m_rowline);
	ps( "萔 : %d \n", n);
}

