enum HighLow {
	HL_UNKNOWN     = 0,
	HL_GT          = 1,						// >
	HL_LT          = 2,						// <
};

/**
 * s
 * MINI BlockLȏꍇƂłȂꍇB
 * BoxԂɕsꍇB̒̕sƂ̏ꍇSĂBoxԂɕs邪C̃vO͖Ăw͂B
 * sƂBoxԂ̊֌WɕsgĂB
 * Ǝ̂SudokuōsCl肵ƂCɂ镛pvZB
 * sɂ镛pׂ͗BoxɂeȂB
 */
class HighLowSudoku : public Sudoku {
public:
	HighLowSudoku( int rows, int cols, int rows_mini_block, int cols_mini_block, int maxval);
	HighLowSudoku( int rows, int cols, int maxval);
	virtual ~HighLowSudoku(){}
	virtual Sudoku* create_clone( const Sudoku* sudoku); // @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
	virtual YesNo solve( YesNo yn_force);
	YesNo set_col_high_low( int row, int col, HighLow hl); // Ԃ̕sw肷
	YesNo set_row_high_low( int row, int col, HighLow hl); // sԂ̕sw肷
	void solve_user();
	void print() const;

protected:
	virtual void decided( int row, int col, BoxVal boxval);	// l肵ƂɏʃNXĂяoB
	void remove_low_equal( int row, int col, BoxVal boxval);
	void remove_high_equal( int row, int col, BoxVal boxval);
	void must_gt( int row1, int col1, int row2, int col2); // [row1][col1]̌l > [row2][col2]̌l, i荞݂oB

protected:
	HighLowSudoku(){}							// create_clone()Ŏgp

private:
	void init();
	void update_min_max();

protected:
	// sBox̉ECBoxƂ̊֌W`B
	HighLow      m_right[ROWS][COLS]; // EBoxƂ̊Ԃɕsꍇ
	HighLow      m_bottom[ROWS][COLS];	// BoxƂ̊Ԃɕsꍇ
	// [row][col]̊֌W𒲂ׂɂ́C
	// BoxƂ̊Ԃ̕s𒲂ׂɂ́Cm_bottom[row-1][col]
	// BoxƂ̊Ԃ̕s𒲂ׂɂ́Cm_right[row][col-1]
	BoxVal        m_boxval_min[ROWS][COLS];
	BoxVal        m_boxval_max[ROWS][COLS];
	YesNo         m_yn_normal;		// MINI BLOCKLǂ?
};

HighLowSudoku::HighLowSudoku( int rows, int cols, int rows_mini_block, int cols_mini_block, int maxval) : Sudoku( rows, cols, maxval)
{
	m_yn_normal   = YES;
	m_rows_mini_block = rows_mini_block;
	m_cols_mini_block = cols_mini_block;
	init();
}

HighLowSudoku::HighLowSudoku( int rows, int cols, int maxval) : Sudoku( rows, cols, maxval)
{
	ps( "HighLowSudoku()\n");
	m_yn_normal   = NO;
	m_rows_mini_block = 0;
	m_cols_mini_block = 0;
	init();
	ps( "end HighLowSudoku()\n");
}

/**
 * @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
 */
Sudoku* HighLowSudoku::create_clone( const Sudoku* src0)
{
	if( src0 == NULL) {
		HighLowSudoku* sudoku = new HighLowSudoku();
		return    sudoku->create_clone( this);
	}
	const HighLowSudoku* src = (const HighLowSudoku*)src0;
	memcpy( m_right, src->m_right, sizeof(m_right));
	memcpy( m_bottom, src->m_bottom, sizeof(m_bottom));
	m_yn_normal   = src->m_yn_normal;
	return    Sudoku::create_clone( src0);
}

YesNo HighLowSudoku::solve( YesNo yn_force)
{
	for( int row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			m_boxval_min[row][col]    = 1;
			m_boxval_max[row][col]    = m_maxval;
		}
	}
	solve_user();									// siv̏ꍇĂȂꍇ̂ŁCŏsolve_user()R[ĂBʂɃR[ȂłOKǁB
	return    Sudoku::solve( yn_force);
}

void HighLowSudoku::update_min_max()
{
	for( int row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			if( m_box[row][col].m_boxval != BoxValNone) {
				m_boxval_min[row][col]  = m_boxval_max[row][col]    = m_box[row][col].m_boxval;
			}
			else {
				BoxVal  boxval_min = m_boxval_min[row][col];
				while( boxval_min <= m_maxval && !(m_box[row][col].m_koho&kohobit[boxval_min])) {
					boxval_min++;
				}
				BoxVal  boxval_max = m_boxval_max[row][col];
				while( boxval_max >= 1 && !(m_box[row][col].m_koho&kohobit[boxval_max])) {
					boxval_max--;
				}
				m_boxval_min[row][col]  = boxval_min;
				m_boxval_max[row][col]  = boxval_max;
			}
		}
	}
}

void HighLowSudoku::init()
{
	memset( m_right, 0, sizeof(m_right));
	memset( m_bottom, 0, sizeof(m_right));
	activate_row_blocks();
	activate_col_blocks();
	if( m_yn_normal) {
		activate_mini_blocks( m_rows_mini_block, m_cols_mini_block);
	}
	calc_box_blocks();
}

/**
 * Box̌lm肵B
 * ㉺E̕s𒲂ׂāČׂli荞ށB
 */
void HighLowSudoku::decided( int row, int col, BoxVal boxval)
{
	ps( "decided(%d,%d,%d)\n", row, col, boxval);
	if( col >= m_cols-1) {}
	else if( m_right[row][col] == HL_GT)  remove_high_equal( row,   col+1, boxval); // E
	else if( m_right[row][col] == HL_LT)  remove_low_equal(  row,   col+1, boxval);
	if( row >= m_rows-1) {}
	else if( m_bottom[row][col] == HL_GT) remove_high_equal( row+1, col,   boxval);	// 
	else if( m_bottom[row][col] == HL_LT) remove_low_equal(  row+1, col,   boxval);
	if( row == 0) {}
	else if( m_bottom[row-1][col] == HL_GT) remove_low_equal(  row-1, col, boxval); // 
	else if( m_bottom[row-1][col] == HL_LT) remove_high_equal( row-1, col, boxval);
	if( col == 0) {}
	else if( m_right[row][col-1] == HL_GT) remove_low_equal(   row, col-1, boxval);	// 
	else if( m_right[row][col-1] == HL_LT) remove_high_equal(  row, col-1, boxval);
	// lm肵̂ŁCőlCŏl͓lɂȂB
	m_boxval_min[row][col]    = boxval;
	m_boxval_max[row][col]    = boxval;
}

void HighLowSudoku::remove_low_equal( int row, int col, BoxVal boxval)
{
	while( boxval >= 1) {
		Sudoku::remove_koho( row, col, boxval);
		boxval--;
	}
}

void HighLowSudoku::remove_high_equal( int row, int col, BoxVal boxval)
{
	while( boxval <= m_maxval) {
		Sudoku::remove_koho( row, col, boxval);
		boxval++;
	}
}

/**
 * Ԃ̕sw肷
 */
YesNo HighLowSudoku::set_col_high_low( int row, int col, HighLow hl)
{
	ps( "set_col_high_low(%d,%d,%d)\n", row, col, hl);
	if( !exist_box( row, col)) return    NO;
	m_right[row][col] = hl;
	return    YES;
}

/**
 * sԂ̕sw肷
 */
YesNo HighLowSudoku::set_row_high_low( int row, int col, HighLow hl)
{
	ps( "set_row_high_low(%d,%d,%d)\n", row, col, hl);
	if( !exist_box( row, col)) return    NO;
	m_bottom[row][col]    = hl;
	return    YES;
}

/**
 */
void HighLowSudoku::solve_user()
{
	update_min_max();							// Sudoku::solve()̒Ōl팸ꂽ\̂ŁCŐV̒lɍXV
	for( int row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			// A<B ̎Cmin(Ǎ̍ŏl)<B̌
			// A>B ̎CǍ>min(B̌̍ŏl)
			// ႦǍ₪2345CB̌₪2345̏ꍇ A>B ł΁CǍ345ɍi荞ݏoB
			if( col >= m_cols-1) {}		// ԉEBox͉EƔr邱Ƃ͖
			else if( m_right[row][col] == HL_GT) {
				must_gt( row, col, row, col+1);
			}
			else if( m_right[row][col] == HL_LT) {
				must_gt( row, col+1, row, col);
			}
			if( row >= m_rows-1) {}		// ԉBox͉Ɣr邱Ƃ͖
			else if( m_bottom[row][col] == HL_GT) {
				must_gt( row, col, row+1, col);
			}
			else if( m_bottom[row][col] == HL_LT) {
				must_gt( row+1, col, row, col);
			}
		}
	}
}

/**
 * [row1][col1]̌l > [row2][col2]̌l, i荞݂oB
 * Box2̌l̍ŏlBox1̌l̍ŏl͑傫Ȃ΂ȂȂB
 * ̂ Box2̌l̍ŏlTCBox1̂ȉ̌l폜B
 * Box2̌l͍őlɂȂ蓾Ȃ̂ō폜łB
 */
void HighLowSudoku::must_gt( int row1, int col1, int row2, int col2)
{
	if( m_boxval_min[row1][col1] <= m_boxval_min[row2][col2]) {	// box1̍ŏl <= box2̍ŏl
		// box1 > box2 Cbox1̍ŏl > box2̍ŏl Ŗ΂ȂȂB
		remove_low_equal( row1, col1, m_boxval_min[row2][col2]); // box2̍ŏl菬l͍폜ł
		m_boxval_min[row1][col1]    = m_boxval_min[row2][col2]+1;	// box1̍ŏlbox2̍ŏl傫̂
	}
	if( m_boxval_max[row1][col1] <= m_boxval_max[row2][col2]) {	// box1̍ől <= box2̍ől
		// box1 > box2 Cbox1̍ől > box2̍ől Ŗ΂ȂȂB
		remove_high_equal( row2, col2, m_boxval_max[row1][col1]);	// box1̍ől傫l͍폜ł
		m_boxval_max[row2][col2]    = m_boxval_max[row1][col1]-1;	// box2̍őlbox1̍ől̂
	}
}

/**
 * m[}Ƃ݂̌̏ԂR\[ɏo͂B
 */
void HighLowSudoku::print() const
{
	ps( "print()\n");
	char          m_rowline[1024];
	{
		int i = 0;
		for( int col=0; col< m_cols; col++) {
			//if( col == 0 || (col % m_cols_mini_block == 0)) m_rowline[i++] = '+';
			if( col == 0) m_rowline[i++] = '+';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
		}
		m_rowline[i++]= '+';
		m_rowline[i]= NIL;
	}

	cstring ss = "EPQRSTUVWX10111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970";
	int           row, col;
	int           n=0;
	for( row=0; row< m_rows; row++) {
		if( row == 0) ps( "%s\n", m_rowline);
		for( col=0; col< m_cols; col++) {
			if( col == 0) ps( "|");
			ps( "%-.2s", ss+get_boxval(row,col)*2);
			if( m_right[row][col] == HL_GT) ps( "");
			else if( m_right[row][col] == HL_LT) ps( "");
			else ps( "@");
			if( get_boxval(row,col) != BoxValNone) n++;
		}
		ps( "|\n");
		for( col=0; col< m_cols; col++) {
			if( col == 0) ps( "|");
			if( m_bottom[row][col] == HL_GT) ps( "u@");
			else if( m_bottom[row][col] == HL_LT) ps( "O@");
			else ps( "@@");
		}
		ps( "|\n");
	}
	ps( "%s\n", m_rowline);
	ps( "萔 : %d \n", n);
}

