const int OVERLAPPEDSUDOKUS = 50;
const int OVERLAPPEDROWS    = 200;
const int OVERLAPPEDCOLS    = 200;

class SudokuInfo {
	friend class OverlappedSudoku;
public:
	SudokuInfo() {}
	~SudokuInfo(){}

private:
	Sudoku*       m_sudoku;				// 
	int           m_row_start;		// 傫ȔՖʏł̈ʒu
	int           m_col_start;
	YesNo         m_yn_must_solve; // solve()Ăяoׂ? ̖ɂĕύX̂ɌĂяô͈ӖȂ̂ŁB
	YesNo         m_yn_solved;		// ?
};

/**
 */
class OverlappedSudoku : public Sudoku {	// SudokuhĂ̂͒PSudokü̖ƍlĂ邩Cۂ͖ƂĂ͗pĂȂ
public:
	OverlappedSudoku();
	~OverlappedSudoku(){}
	YesNo solve( YesNo yn_force);
	void print() const;

	int add( Sudoku* sudoku);			// Ƃǉ
	YesNo remove( int idx);				// Ƃ폜
	YesNo move( int idx, int row, int col);	// 

private:
	YesNo solve_private( YesNo yn_foce);
	YesNo check_changed( int idx); // eՖʂsolve()̌ʕύX?
	YesNo rowcol2insiderowcol( int idx, int row, int col, int& row_inside, int& col_inside) const;
	YesNo notice_decided_boxval( int idx, int row, int col, BoxVal boxval);
	YesNo notice_remove_koho( int idx, int row, int col, Koho koho);
	int get_remove_boxval( Koho koho_old, Koho koho_new, BoxVal boxval[MAXVAL]); // koho_oldkoho_new̍̌lo
	YesNo initialize_boxval();

private:
	int           m_num_sudoku;
	int           m_last_index;		// m_sudoku[]̂gĂꏊ̍Ō̈ʒuwB
	SudokuInfo    m_sudoku[OVERLAPPEDSUDOKUS];
	BoxVal        m_boxval[OVERLAPPEDROWS][OVERLAPPEDCOLS];
	Koho          m_koho[OVERLAPPEDROWS][OVERLAPPEDCOLS];
	int           m_cnt_solved;
};

OverlappedSudoku::OverlappedSudoku() : Sudoku( 2, 2, 1) 
{
	m_num_sudoku  = 0;
	m_last_index  = -1;
	memset( m_boxval, 0, sizeof(m_boxval));
	memset( m_koho, 0, sizeof(m_koho));
	m_cnt_solved  = 0;
}

/**
 * 󂫃Xy[XĂɓo^B
 */
int OverlappedSudoku::add( Sudoku* sudoku)
{
	ps( "OverlappedSudoku::add()\n");
	int           idx = m_last_index+1;
	if( m_num_sudoku > m_last_index) { // 󂫃Xy[X͖̂ňԍŌɒǉ
		m_last_index++;
	}
	else {												// rɋ󂫂̂łT
		for( int i=0; i< m_last_index; i++) {
			if( m_sudoku[i].m_sudoku == NULL) {	// 󂢂ĂXy[X?
				idx     = i;
				break;
			}
		}
	}
	mt_assert( idx >= 0 && idx < OVERLAPPEDSUDOKUS);
	m_sudoku[idx].m_sudoku    = sudoku;
	m_sudoku[idx].m_row_start = 0;
	m_sudoku[idx].m_col_start = 0;
	m_sudoku[idx].m_yn_must_solve     = YES;
	m_sudoku[idx].m_yn_solved         = NO;
		m_num_sudoku++;
	return    idx;
}

YesNo OverlappedSudoku::remove( int idx)
{
	if( m_sudoku[idx].m_sudoku != NULL) {
		Sudoku*     sudoku = m_sudoku[idx].m_sudoku;
		m_sudoku[idx].m_sudoku  = NULL;
		delete    sudoku;
		return    YES;
	}
	return    NO;
}

/**
 * ʒuړB
 */
YesNo OverlappedSudoku::move( int idx, int row, int col)
{
	mt_assert( idx >= 0 && idx < OVERLAPPEDSUDOKUS);
	mt_assert( m_sudoku[idx].m_sudoku != NULL);
	if( idx < 0 || idx >= OVERLAPPEDSUDOKUS) return    NO;
	if( m_sudoku[idx].m_sudoku == NULL) return    NO;
	int           row_max = row + m_sudoku[idx].m_sudoku->get_rows()-1;
	int           col_max = col + m_sudoku[idx].m_sudoku->get_cols()-1;
	// ͂ݏoȂ?
	if( row_max >= OVERLAPPEDROWS) return    NO;
	if( col_max >= OVERLAPPEDCOLS) return    NO;

	// ͂ݏoȂƂB
	m_sudoku[idx].m_row_start = row;
	m_sudoku[idx].m_col_start = col;
	return    YES;
}

YesNo OverlappedSudoku::solve( YesNo yn_force)
{
	ps( "OverlappedSudoku::solve(m_num_sudoku:%d)\n", m_num_sudoku);
	{															// for DEBUG
		for( int i=0; i<= m_last_index; i++) {
			if( m_sudoku[i].m_sudoku == NULL) continue;
			m_sudoku[i].m_sudoku->print();
			m_sudoku[i].m_sudoku->dump_koho();
		}
	}
	if( m_num_sudoku == 0) return    NO; // 肪
	if( initialize_boxval() == NO) return    NO; // 
	YesNo yn_solved = solve_private( NO);	// @ŉĂ݂
	if( yn_solved) return    YES;	// @ŉȂ炻HappyłˁB
	// ȂB
	// 𒲂ׂāCf[^G[^CAEgȂΒ߂
	for( int i=0; i<= m_last_index; i++) {
		if( m_sudoku[i].m_sudoku == NULL) continue;
		if( m_sudoku[i].m_sudoku->is_data_error()) return    NO; // f[^G[̂Œ߂
		if( m_sudoku[i].m_sudoku->is_timeout()) return    NO;	// ^CAEĝŒ߂(ʉ@gȂƃ^CAEg͖͂)
	}
	if( yn_force) {								// @Ă݂B
		yn_solved   = solve_private( YES); // @Ă݂
		if( yn_solved) return    YES;	// ƂȂ炻͂HappyB
		// Ȃꍇ̓f[^G[^CAEgȂ͂,ǃf[^G[ȂCȑOɃ`FbNĂĂȂB
		// ܂CÔ߃f[^G[̉\`FbNĂ݂B
		for( int i=0; i<= m_last_index; i++) {
			if( m_sudoku[i].m_sudoku == NULL) continue;
			if( m_sudoku[i].m_sudoku->is_data_error()) return    NO; // f[^G[̂Œ߂
			if( m_sudoku[i].m_sudoku->is_timeout()) return    NO;	// ^CAEĝŒ߂(ʉ@gȂƃ^CAEg͖͂)
		}
		// ɗ邱Ƃ͖͂,Ȃꍇ͏L̂ǂ炩̗RŃ`FbNɊ|Ă͂B
		// 肪ꍇԏŃ`FbNĂ̂łɗ邱Ƃ͖͂
		mt_assert(false);
	}
	return    NO;
}

/**
 * `ĂSĂ̖Ă݂B
 * @gǂ yn_force Ŏw肷B
 */
YesNo OverlappedSudoku::solve_private( YesNo yn_force)
{
	int           i;
	m_cnt_solved  = 0;						// ܂Ă͈̂
	for( i=0; i<= m_last_index; i++) { // ŏ͕K悤ɐݒ肵ĂB2ڈȍ~́CύXƂ悤ɂB
		m_sudoku[i].m_yn_must_solve = YES;
	}
	YesNo         yn_exec;
 once:
	yn_exec       = NO;						// ǂɍXVӏYESɐݒ肷B
	for( i=0; i<= m_last_index; i++) {
		if( m_sudoku[i].m_sudoku == NULL) continue;	// 肪B
		if( m_sudoku[i].m_yn_must_solve == NO) continue; // KvB
		YesNo yn_solve = m_sudoku[i].m_sudoku->solve( yn_force); // Ă݂
		if( yn_solve) {							// ?
			m_sudoku[i].m_yn_solved   = YES;
		}
		else if( m_sudoku[i].m_sudoku->is_data_error()) {
			return    NO;
		}
		else if( m_sudoku[i].m_sudoku->is_timeout()) {
			return    NO;
		}
		// solve()̌ʁCύX?
		// ܂[Blm肵ȂĂCl̍i荞݂sꍇ񂾁B[Bm_koho[][]ǉB
		if( check_changed( i)) {		// ml͌lɕωǂׂB
																// ̖Ƃ̏dȂ`FbNāCyn_must_solve XV
			yn_exec   = YES;
		}
		{														// for DEBUG
			for( int k=0; k<= m_last_index; k++) {
				if( m_sudoku[k].m_sudoku == NULL) continue;
				ps( "solve(%d) end\n", k);
				m_sudoku[k].m_sudoku->print();
				m_sudoku[k].m_sudoku->dump_koho();
			}
		}
	}
	if( yn_exec) goto once;
	// XVӏȂ
	m_cnt_solved  = 0;
	for( i=0; i<= m_last_index; i++) {
		if( m_sudoku[i].m_sudoku == NULL) continue;
		if( m_sudoku[i].m_yn_solved) m_cnt_solved++;
	}
	if( m_cnt_solved == m_num_sudoku) return    YES; // SĂ̔ՖʂĂ
	return    NO;									// ĂȂՖʂȂƂ͂
}

/**
 * ՖʂɕύX?
 * ύXCύXeՖʂ m_must_solve YESݒ肷B
 */
YesNo OverlappedSudoku::check_changed( int idx)
{
	mt_assert( idx >= 0 && idx < OVERLAPPEDSUDOKUS);
	mt_assert( m_sudoku[idx].m_sudoku != NULL);
	Sudoku*       sudoku = m_sudoku[idx].m_sudoku;
	if( sudoku == NULL) return    NO;
	int           rows = sudoku->get_rows();
	int           cols = sudoku->get_cols();
	int           row, col;
	BoxVal        boxval;
	Koho          koho;
	YesNo         yn_changed = NO;
	for( int irow=0; irow< rows; irow++) {
		for( int icol=0; icol< cols; icol++) {
			row       = m_sudoku[idx].m_row_start + irow;
			col       = m_sudoku[idx].m_col_start + icol;
			boxval    = sudoku->get_boxval( irow, icol);
			if( m_boxval[row][col] != boxval) {	// lm肵
				m_boxval[row][col]  = boxval;
				yn_changed  = YES;
				if( notice_decided_boxval( idx, row, col, boxval) == NO) return    NO; // ̔ՖʂɊmlABf[^ɃG[ꍇ̔ՖʂG[ԂĂꍇB
			}
			else if( m_koho[row][col] != (koho=sudoku->get_koho( irow, icol))) { // ܂lm肵ĂȂCl͕ύXɂȂ?
				// lύXɂȂB̔ՖʂɌl̕ύXAB
				// ӂȂ΂ȂȂ̂́CՖʂ̑傫Ⴄ\邱ƂłB
				// ?B
				// 3x3  3x4 ̏dȂƂǂ?
				// 菭Ȃl̗pĂƂŗǂ?
				if( countbit(m_koho[row][col]) < countbit(koho)) {
					ps( "nĂȂ\n");
				}
				else if( countbit(m_koho[row][col]) == countbit(koho)) {
					ps( "l̐ %d %d\n", countbit(m_koho[row][col]), countbit(koho));
					ps( "l͓̐lႤ%d[%d][%d]%d, oldkoho:%d\n", idx, row, col, koho, m_koho[row][col]);
				}
				yn_changed  = YES;
				if( notice_remove_koho( idx, row, col, koho)) {
				}
				m_koho[row][col]  = koho;
			}
		}
	}
	return    yn_changed;
}

/**
 * Ֆʂ̒lύXɂȂƂ𑼂̔ՖʂɘAB
 * idx͊ɂ̂Ƃ𗝉ĂՖ(lύXɂȂՖ)B
 */
YesNo OverlappedSudoku::notice_decided_boxval( int idx, int row, int col, BoxVal boxval)
{
	int           row_inside, col_inside;
	for( int i=0; i<= m_last_index; i++) {
		if( i == idx) continue;			// ɗĂՖ
		if( m_sudoku[i].m_sudoku == NULL) continue;	// ʒmׂՖʂ
		if( rowcol2insiderowcol( i, row, col, row_inside, col_inside)) { // [row][col]Ŏw肵BOX̔Ֆʂɑ݂邩?
			if( m_sudoku[i].m_sudoku->set_boxval( row_inside, col_inside, boxval) == NO) return NO;
		}
	}
	return    YES;
}

/**
 * l폜ł邱Ƃ𑼂̔ՖʂɂAB
 */
YesNo OverlappedSudoku::notice_remove_koho( int idx, int row, int col, Koho remove_koho)
{
	BoxVal        remove_boxval[MAXVAL];
	int           n = get_remove_boxval( m_koho[row][col], remove_koho, remove_boxval); // 폜lzɋ߂B
	ps( "notice_remove_koho(%d̌l폜Ώ,oldkoho:%d,newkoho:%d\n", n, m_koho[row][col], remove_koho);
	for( int i=0; i<= m_last_index; i++) {
		if( i == idx) continue;			// ɗĂՖ
		if( m_sudoku[i].m_sudoku == NULL) continue;	// Ֆʂ
		int         row_inside, col_inside;
		if( rowcol2insiderowcol( i, row, col, row_inside, col_inside)) { // Ŝ̔Ֆʂ̈ʒuΏۂ̔Ֆʂ̈ʒuɕϊ
			int       maxval = m_sudoku[i].m_sudoku->get_maxval(); // Ֆʂ̍ől
			for( int j=0; j< n; j++) {
				if( remove_boxval[j] <= maxval) {	// Ֆʂ̍ől傫Ȓl폜ɂȂ邱ƂB3x33x4̃m[}ƂdȂƂB
					ps( "remove_koho[%d][%d][%d]boxval:%d\n", i, row_inside, col_inside, remove_boxval[j]);
					m_sudoku[i].m_sudoku->remove_koho( row_inside, col_inside, remove_boxval[j]);	// l폜B
				}
			}
		}
	}
	return    YES;
}

/**
 * m_sudoku[idx][row][col]݂邩?
 * [row][col]͑Ŝ̔ՖʁB
 */
YesNo OverlappedSudoku::rowcol2insiderowcol( int idx, int row, int col, int& row_inside, int& col_inside) const
{
	if( m_sudoku[idx].m_sudoku == NULL) return    NO;
	row_inside    = row - m_sudoku[idx].m_row_start;
	col_inside    = col - m_sudoku[idx].m_col_start;
	return    m_sudoku[idx].m_sudoku->exist_box( row-m_sudoku[idx].m_row_start, col-m_sudoku[idx].m_col_start);
}

/**
 * 폜l̈ꗗ擾B
 * koho_old ɂāCkoho_new ɖloB
 */
int OverlappedSudoku::get_remove_boxval( Koho koho_old, Koho koho_new, BoxVal boxval[MAXVAL])
{
	Koho          koho_diff = koho_old & ~koho_new;	// koho_old ɂ koho_new ɖ
	int           cnt_loop = sizeof(Koho)*8/8; // 8rbgo
	BoxVal        v = 0;
	int           n = 0;
	for( int i=0; i< cnt_loop; i++) {
		v++;
		if( koho_diff & 1) boxval[n++] = v;
		v++;
		if( koho_diff & 2) boxval[n++] = v;
		v++;
		if( koho_diff & 4) boxval[n++] = v;
		v++;
		if( koho_diff & 8) boxval[n++] = v;
		v++;
		if( koho_diff & 16) boxval[n++] = v;
		v++;
		if( koho_diff & 32) boxval[n++] = v;
		v++;
		if( koho_diff & 64) boxval[n++] = v;
		v++;
		if( koho_diff & 128) boxval[n++] = v;
		koho_diff   >>= 8;
	}
	return    n;
}

/**
 * m_boxval[][] B
 */
YesNo OverlappedSudoku::initialize_boxval()
{
	memset( m_boxval, 0, sizeof(m_boxval));
	memset( m_koho, 0, sizeof(m_koho));
	for( int i=0; i< m_last_index; i++) {
		if( m_sudoku[i].m_sudoku == NULL) continue;
		int         row_start = m_sudoku[i].m_row_start;
		int         col_start = m_sudoku[i].m_col_start;
		int         rows = m_sudoku[i].m_sudoku->get_rows();
		int         cols = m_sudoku[i].m_sudoku->get_cols();
		BoxVal      boxval;
		int         maxval = m_sudoku[i].m_sudoku->get_maxval();
		for( int irow=0; irow< rows; irow++) {
			for( int icol=0; icol< cols; icol++) {
				int     row = row_start + irow;
				int     col = col_start + icol;
				boxval  = m_sudoku[i].m_sudoku->get_boxval( irow, icol);
				if( m_boxval[row][col] != BoxValNone) {	// ɐݒ肳Ă
					if( m_boxval[row][col] != boxval) {	// [Cʂ̔ՖʂƒlႤB蓾ȂB
						return    NO;
					}
				}
				else {
					m_boxval[row][col]    = boxval;
					if( boxval != BoxValNone) {
						m_koho[row][col]    = 0; // lm肵Ă
					}
					else {
						m_koho[row][col]    |= Sudoku::get_all_koho( maxval);	// lm肵ĂȂƂ͂傫ȔՖʂ̌l̗pB
					}
				}
			}
		}
	}
	return    YES;
}

/**
 */
void OverlappedSudoku::print() const
{
}
